package no.ntnu.item.router;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.List;

import no.ntnu.item.router.enums.PlayState;

/**
 * Domain object representing a measurement received from Silverlight
 * 
 * @author Kristian Haugene
 * 
 */
public class SilverlightMeasurement {

	private String event, eventMessage, clientId, ispAS;
	private PlayState playState;
	private Boolean fullScreen;
	private Double avgProcessorLoad, avgProcessLoad, timeIncrement;
	private Integer videoDownloadBitrate;
	private List<Integer> avaliableVideoBitrates;
	private InetSocketAddress sourceIpAndPort;
	private InetAddress myIp;
	private Long routerTimeStamp;

	/**
	 * s Parameterized constructor
	 */
	public SilverlightMeasurement(String event, String eventMessage,
			String clientId, String ispAS, PlayState playState,
			Boolean fullScreen, Double avgProcessorLoad, Double avgProcessLoad,
			Double timeIncrement, Integer videoDownloadBitrate,
			List<Integer> avaliableVideoBitrates, InetAddress myIp,
			InetSocketAddress sourceIpAndPort, Long routerTimeStamp) {

		this.event = event;
		this.eventMessage = eventMessage;
		this.clientId = clientId;
		this.ispAS = ispAS;
		this.playState = playState;
		this.fullScreen = fullScreen;
		this.avgProcessorLoad = avgProcessorLoad;
		this.avgProcessLoad = avgProcessLoad;
		this.timeIncrement = timeIncrement;
		this.videoDownloadBitrate = videoDownloadBitrate;
		this.avaliableVideoBitrates = avaliableVideoBitrates;
		this.myIp = myIp;
		this.sourceIpAndPort = sourceIpAndPort;
		this.routerTimeStamp = routerTimeStamp;

	}

	/*
	 * Getters for all fields
	 */
	public String getEvent() {
		return event;
	}

	public String getEventMessage() {
		return eventMessage;
	}

	public String getClientId() {
		return clientId;
	}

	public String getIspAS() {
		return ispAS;
	}

	public PlayState getPlayState() {
		return playState;
	}

	public Boolean getFullScreen() {
		return fullScreen;
	}

	public Double getAvgProcessorLoad() {
		return avgProcessorLoad;
	}

	public Double getAvgProcessLoad() {
		return avgProcessLoad;
	}

	public Double getTimeIncrement() {
		return timeIncrement;
	}

	public Integer getVideoDownloadBitrate() {
		return videoDownloadBitrate;
	}

	public List<Integer> getAvaliableVideoBitrates() {
		return avaliableVideoBitrates;
	}

	public InetAddress getMyIp() {
		return myIp;
	}

	public InetSocketAddress getSourceIpAndPort() {
		return sourceIpAndPort;
	}

	public Long getRouterTimeStamp() {
		return routerTimeStamp;
	}

}
