﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Web.Media.SmoothStreaming;

namespace UserControlledApplication
{
    public partial class MainPage : UserControl
    {
        StatisticsProcess statisticsProcess;

        public MainPage()
        {
            InitializeComponent();
            statisticsProcess = new StatisticsProcess(this, SmoothPlayer, infoBlock);

        }

        /*
         * The event handlers call corresponding methods in the StatisticsProcess object
         */

        private void SmoothPlayer_CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            //infoBlock.Text = (sender as SmoothStreamingMediaElement).CurrentState.ToString();
            statisticsProcess.playStateChanged((sender as SmoothStreamingMediaElement).CurrentState.ToString());
        }

        private void SmoothPlayer_PlaybackTrackChanged(object sender, TrackChangedEventArgs e)
        {
            //infoBlock.Text = (sender as SmoothStreamingMediaElement).VideoPlaybackTrack.Bitrate.ToString();
            statisticsProcess.downloadBitrateChanged((sender as SmoothStreamingMediaElement).VideoPlaybackTrack.Bitrate.ToString());
        }

        private void SmoothPlayer_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            //infoBlock.Text = Application.Current.Host.Content.IsFullScreen.ToString();
            statisticsProcess.fullScreenChanged(Application.Current.Host.Content.IsFullScreen.ToString());
        }


        /*
         * BASIC CONTROLS FOR MEDIA PLAYER
         */

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Host.Content.IsFullScreen = !Application.Current.Host.Content.IsFullScreen;
        }

        private void PlayButton_Click(object sender, RoutedEventArgs e)
        {
            SmoothPlayer.Play();
        }

        private void StopButton_Click(object sender, RoutedEventArgs e)
        {
            SmoothPlayer.Stop();
        }

        private void PauseButton_Click(object sender, RoutedEventArgs e)
        {
            SmoothPlayer.Pause();
        }

        private void SmoothPlayer_ManifestReady(object sender, EventArgs e)
        {
            //foreach (SegmentInfo segment in SmoothPlayer.ManifestInfo.Segments)
            //{
            //    IList<StreamInfo> streamInfoList = segment.AvailableStreams;
            //    foreach (StreamInfo stream in streamInfoList)
            //    {
            //        if (stream.Type == MediaStreamType.Video)
            //        {
            //            // Limit bit-rate to 1636000.
            //            ulong highRate = 1636000 + 1;
            //            List<TrackInfo> tracks = new List<TrackInfo>();

            //            tracks = stream.AvailableTracks.ToList<TrackInfo>();
            //            IList<TrackInfo> allowedTracks = tracks.Where((ti) => ti.Bitrate < highRate).ToList();
            //            stream.SelectTracks(allowedTracks, false);
            //        }
            //    }
            //}


        }

    }
}
