<html><body>
<?php

	//Variable to hold the path of the file
	$date = date(dmy);
	$myFile = '/var/www/logger/logs/log'.$date.'.txt';

	// Need a separate file to maintain information of logs sequence numbering
	$seqFile = '/var/www/logger/seqNumbering.txt';

	// Make the log string for this entry
        $logEntry = "";

	// Append all server side parameters
	$logEntry = $logEntry.get_seqNumber($seqFile, $date).";";
	$logEntry = $logEntry.get_hexClientId($_POST["clientId"]).";";

	list($totalSeconds, $extraMilliseconds) = timeAndMilliseconds();
	$logEntry = $logEntry.get_humanReadableTimeWithMillis($totalSeconds, $extraMilliseconds).";";
	$logEntry = $logEntry.get_unixTimeWithMillis($totalSeconds, $extraMilliseconds).";";

	// Then the ones passed through POST
	$logEntry = $logEntry.$_POST["event"].";";
        $logEntry = $logEntry.$_POST["eventMessage"].";";
        $logEntry = $logEntry.$_POST["playState"].";";
	$logEntry = $logEntry.$_POST["fullScreen"].";";
        $logEntry = $logEntry.$_POST["clientId"].";";
        $logEntry = $logEntry.$_POST["avgProcessorLoad"].";";
        $logEntry = $logEntry.$_POST["avgProcessLoad"].";";
        $logEntry = $logEntry.$_POST["videoDownloadBitrate"].";";
        $logEntry = $logEntry.$_POST["avaliableVideoBitrates"].";";
        $logEntry = $logEntry.$_POST["myIp"].";";
        $logEntry = $logEntry.$_POST["ispAS"].";";
        $logEntry = $logEntry.$_POST["sourceIpAndPort"].";";
        $logEntry = $logEntry.$_POST["timeIncrement"]."\n";

	// Open file, write it, close it
        $fh = fopen($myFile, 'a') or die("can't open file");
        fwrite($fh, $logEntry);
        fclose($fh);

	//echo "Registered bitrate: ".$_POST["bitRate"]." at timestamp: ".$_POST["timestamp"];

	function get_humanReadableTimeWithMillis($numSeconds, $numMillisec)
		{
			return date("H:i:s", $numSeconds) . ",$numMillisec";
		}

	function get_unixTimeWithMillis($numSeconds, $numMillisec)
		{
			return $numSeconds.",$numMillisec";
		}

	// Returns an array with seconds and milliseconds in that order
	function timeAndMilliseconds()
		{
    			$m = explode(' ',microtime());
    			return array($m[1], (int)round($m[0]*1000,3));
		} 

	// To be more sort-friendly we get a plain hex clientId without '-' chars
	function get_hexClientId($originalClientId)
		{
			// return string after removing -
			return str_replace("-", "", $originalClientId);
		}

	// Function to get the correct sequence number of the day
	function get_seqNumber($numberFile, $dateToday)
	{
		// The sequence number and date to return
		$returnDate = "";
		$returnSeq = "";

		// Read the current seqNumber info
		$fh = fopen($numberFile, 'r');
		$currentData = fread($fh, filesize($numberFile));
		fclose($fh);

		// Split the input data into day and sequence number
		$dataArray = explode(";", $currentData);
		$writtenDate = $dataArray[0];
		$writtenSeq = $dataArray[1];

		// Check if the date is correct. If not, we need to start at 1 again
		if( strcmp ($writtenDate, $dateToday) == 0)
			{
				// It's the same date, update seq number
				$writtenSeqInt = (int)$writtenSeq;
				$returnDate = $writtenDate;
				$returnSeq = $writtenSeqInt+1;

			} else {
				// The date has changed, update it and start over
				$returnDate = $dateToday;
				$returnSeq = 1;
			}

		// Write the new information to file
		$fh = fopen($numberFile, 'w') or die("can't open file");
		$stringData = "$returnDate".";"."$returnSeq";
		fwrite($fh, $stringData);
		fclose($fh);

		// Print debug info - SHOULD BE REMOVED!!!
		echo "Read date "."$writtenDate"." and seq "."$writtenSeq"."\n";
		echo "Wrote date "."$returnDate"." and seq "."$returnSeq";

		// And return the seqNumber
		return $returnSeq;
	}
?>
	<p>The file was run</p>
</body></html>
