<?php

$timeStampStorage = array();
$bitRateStorage = array();
$allTimeStamps = array();
$newBitRateStorage = array();
$clientIdStorage = array();

$randomId = rand(0, 100000);

$objDOM = new DOMDocument();
//$objDOM->load("../data/webUi?randomInt=".$randomId); //make sure path is correct

$objDOM->load("http://click22.item.ntnu.no/data/webUi.xml?random=$randomId");

$bitRateStatistics = $objDOM->getElementsByTagName("bitRateStatistics");

$nrOfServiceFlows = 0;
$nrOfBitRates = 0;
$nrOfTimeStamps = 0;
$clientID = 0;

foreach ($bitRateStatistics as $value) {
    $nrOfServiceFlows++;
    $entry = $value->getElementsByTagName("entry");
    foreach ($entry as $value) {
        $bitrates = $value->getElementsByTagName("bitRate");
        $bitRateStorage[$clientID][$nrOfBitRates] = $bitrates->item(0)->nodeValue;
        $nrOfBitRates++;

        $timeStamps = $value->getElementsByTagName("timeStamp");
        $timeStamp = $timeStamps->item(0)->nodeValue;
        $timeStampStorage[$clientID][$nrOfTimeStamps] = $timeStamp;

        storeAllTimeStampsInArray($timeStamp);

        $nrOfTimeStamps++;
    }
    $totalNrOfBitrates = $nrOfBitRates;
    $nrOfBitRates = 0;
    $nrOfTimeStamps = 0;
    $clientID++;
}

///////////////////////////////////////////////////////////////////////////
// PHP functions
///////////////////////////////////////////////////////////////////////////


/*
 * Function which stores a timestamp in the timestamp array.
 */
function storeAllTimeStampsInArray($time) {
    global $totalNrOfTimeStamps, $allTimeStamps;
    $allTimeStamps[$totalNrOfTimeStamps] = $time;
    $totalNrOfTimeStamps++;

    //Sort the array of timestamps.
    sort($allTimeStamps);
}

/*
 * Function which prints all timestamps.
 */

function printTimeStamps() {
    global $totalNrOfTimeStamps, $allTimeStamps;

    print "<chart>";
    print "   <chart_data>";
    print "      <row>";
    print "         <null/>";

    for ($i = 0; $i < $totalNrOfTimeStamps; $i++) {
        $time =  $allTimeStamps[$i]/1000;
        print "         <string>" . date('H:i:s', $time) . "</string>";
    }

    print "      </row>";
}

/*
 * Function which prepares the clients bitrates for the graph.
 * Iterates through bitrates statistics and compares them to timestamp.
 */

function prepareClientBitRatesForGraph($clientNr) {
    global $bitRateStorage, $allTimeStamps, $timeStampStorage, $newBitRateStorage;

    $clientTimeStampIterator = 0;

    for ($q = 0; $q < sizeof($allTimeStamps); $q++) {
        //Check if the end of the timestamp storage for each client is reached.
        if ($clientTimeStampIterator < sizeof($timeStampStorage[$clientNr])) {
            //When the array containing the timestamp for all measurements is
            //less than the timestamp of each individual clients bitrate measurement, 
            //set the bitrate to 0 if it is the first measurement. If not set the bitrate
            //to the same as the previous bit rate.
            if ($allTimeStamps[$q] < $timeStampStorage[$clientNr][$clientTimeStampIterator]) {
                if ($clientTimeStampIterator == 0) {
                    $newBitRateStorage[$clientNr][$q] = 0;
                } else {
                    $newBitRateStorage[$clientNr][$q] = $newBitRateStorage[$clientNr][$q - 1];
                }
            } else {
                $newBitRateStorage[$clientNr][$q] = $bitRateStorage[$clientNr][$clientTimeStampIterator];
                $clientTimeStampIterator++;
            }
        } else {
            $newBitRateStorage[$clientNr][$q] = $newBitRateStorage[$clientNr][$q - 1];
        }
    }
}

function printClientBitrates($clientNr) {
    global $newBitRateStorage, $clientIdStorage;

    getClientIds();

    print "      <row>";
    print "         <string>Client " . $clientIdStorage[$clientNr] . "</string>";


    foreach ($newBitRateStorage as $client => $thisBitRate) {

        if ($client == $clientNr) {
            foreach ($thisBitRate as $value) {
                print "         <number>" . $value . "</number>";
            }
        }
    }
    print "      </row>";
}

/*
 * Function which gets all client ids from xml and stores them in array.
 */

function getClientIds() {
    global $clientIdStorage, $randomId;
    $nrOfClientIds = 0;

    $objDOM = new DOMDocument();
    $objDOM->load("http://click22.item.ntnu.no/data/webUi.xml?random=$randomId"); //make sure path is correct 

    $serviceSessons = $objDOM->getElementsByTagName("serviceSession");
    foreach ($serviceSessons as $value) {
        $clientIDs = $value->getElementsByTagName("clientId");
        $clientIdStorage[$nrOfClientIds] = $clientIDs->item(0)->nodeValue;
        $nrOfClientIds++;
    }
}

///////////////////////////////////////////////////////////////////////////
// End PHP functions
///////////////////////////////////////////////////////////////////////////

printTimeStamps();

//Iterate through all running service flows and print info.
for ($serviceFlowIterator = 0; $serviceFlowIterator < $nrOfServiceFlows; $serviceFlowIterator++) {
    prepareClientBitRatesForGraph($serviceFlowIterator);
    printClientBitrates($serviceFlowIterator);
}

print "   </chart_data>";

//schedule for the next update
//print "   <update url='http://localhost/clickRouterUI/charts/getGraphEntries.php?time=" . time() . "&previousNrOfServiceFlows=$nrOfServiceFlows' delay='1' mode='data' /> ";



print "   <update url='../charts/getGraphEntries.php?uniqueID=" . $randomId . "&previousNrOfServiceFlows=$nrOfServiceFlows' delay='1' mode='normal' span='5' /> ";
print "</chart>";
?>

